<?php
/* 
Plugin Name: A_fw_matrix
Version: 1.0.0
Plugin URI: http://www.wieser.at/wordpress/plugins
Description: fw_matrix
Author URI: http://www.wieser.at
Licenc:  GPLv2
*/ 

// Register Custom Post Type - Workshop
// 
// 

/*register_deactivation_hook( __FILE__, 'flush_rewrite_rules' );
register_activation_hook( __FILE__, 'myplugin_flush_rewrites' );
function myplugin_flush_rewrites() {
	myplugin_custom_post_types_registration();
	flush_rewrite_rules();
}
*/
function fw_matrix_cpt() {
    
	$args = array(
		'label' => __( 'Matrix', 'fw_matrix' ),
		'description' => __( 'Matrix Verwaltung', 'fw_matrix' ),
		'labels' => $labels,
		'supports' => array( 'title', 'editor', 'thumbnail', 'comments', 'revisions', 'custom-fields' ),
		'taxonomies' => array( 'category','square' ),
		'hierarchical' => false,
		'public' => true,
		'show_ui' => true,
		'show_in_menu' => true,
		'menu_position' => 20,
		'menu_icon' => 'dashicons-welcome-learn-more',
		'show_in_admin_bar' => true,
		'show_in_nav_menus' => true,
		'can_export' => true,
		'has_archive' => true,
		'exclude_from_search' => false,
		'publicly_queryable' => true,
		'capability_type' => 'page',
		'show_in_rest' => true,
	);
    
    register_post_type( 'matrix', $args );
  
  //Taxonomie Regisgter 
  
  $labels = array(
		'name'              => _x( 'Square', 'taxonomy general name', 'textdomain' ),
		'singular_name'     => _x( 'Square', 'taxonomy singular name', 'textdomain' ),
		'search_items'      => __( 'Search data', 'textdomain' ),
		'all_items'         => __( 'All data', 'textdomain' ),
		'parent_item'       => __( 'Parent data', 'textdomain' ),
		'parent_item_colon' => __( 'Parent data:', 'textdomain' ),
		'edit_item'         => __( 'Edit data', 'textdomain' ),
		'update_item'       => __( 'Update data', 'textdomain' ),
		'add_new_item'      => __( 'Add New data', 'textdomain' ),
		'new_item_name'     => __( 'New Squere', 'textdomain' ),
		'menu_name'         => __( 'Square', 'textdomain' ),
	);

$args = array(
		'hierarchical'      => true,
		'labels'            => $labels,
  		'public'			=> true,
		'show_ui'           => true,
		'show_admin_column' => true,
		'query_var'         => true,
  'capabilities'      => array(
	//				'assign_terms' => 'manage_options',
		'edit_terms'   => 'manage_options',
					'manage_terms' => 'manage_options',
				),
		'rewrite'           => array( 'slug' => 'square' ),
	);
  register_taxonomy( 'square', array( 'matrix'), $args );

	$term = term_exists( 'posttype', 'square' );
if ( $term == 0 || $term == null ) {
  echo "'Uncategorized' category exists!";
 wp_insert_term(
  'Posttype', // the term 
  'square', // the taxonomy
  array(
    'description'=> 'Erstellen von Post Type.',
    'slug' => array( 'posttype' ),
    )
);

  }
/*$term = term_exists( 'taxonomie', 'square' );
if ( $term == 0 || $term == null ) {
 wp_insert_term(
  'Taxonomie', // the term 
  'square', // the taxonomy
  array(
    'description'=> 'Erstellen von Taxonomie.',
    'slug' => 'taxonomie',
    )
);
  }
	$term = term_exists( 'postterm', 'square' );
if ( $term == 0 || $term == null ) {
 wp_insert_term(
  'Post to Term', // the term 
  'square', // the taxonomy
  array(
    'description'=> 'Post erzeugt Term',
    'slug' => 'postterm',
    )
);
  }
*/
//Taxonomie Regisgter 
  
  $labels = array(
		'name'              => _x( 'Status', 'taxonomy general name', 'textdomain' ),
		'singular_name'     => _x( 'Status', 'taxonomy singular name', 'textdomain' ),
		'search_items'      => __( 'Search data', 'textdomain' ),
		'all_items'         => __( 'All data', 'textdomain' ),
		'parent_item'       => __( 'Parent data', 'textdomain' ),
		'parent_item_colon' => __( 'Parent data:', 'textdomain' ),
		'edit_item'         => __( 'Edit data', 'textdomain' ),
		'update_item'       => __( 'Update data', 'textdomain' ),
		'add_new_item'      => __( 'Add New data', 'textdomain' ),
		'new_item_name'     => __( 'New Squere', 'textdomain' ),
		'menu_name'         => __( 'Status', 'textdomain' ),
	);

$args = array(
		'hierarchical'      => true,
		'labels'            => $labels,
  		'public'			=> true,
		'show_ui'           => true,
		'show_admin_column' => true,
		'query_var'         => true,
  'capabilities'      => array(
	//				'assign_terms' => 'manage_options',
		'edit_terms'   => 'manage_options',
					'manage_terms' => 'manage_options',
				),
		'rewrite'           => array( 'slug' => 'status' ),
	);
  register_taxonomy( 'status', array( 'post' ), $args );
	
	// Taxonomies Matrix register
	$argt=array(
  	
  	'post_type' => 'matrix',
  	'posts_per_page'=>'-1',
		'tax_query' => array(
		array(
			'taxonomy' => 'square',
			'field' => 'slug',
			'terms' => 'taxonomie'
		)
	)
  	);
	
$dbstaxonomies = get_posts( $argt );
foreach ( $dbstaxonomies as $dbstax ) :
  setup_postdata( $dbstax );  
  $dbstaxpost_type=get_post_meta($dbstax->ID,'post_type',false);
	$labels = array(
		'name'                       => _x( $dbstax->post_title, 'Taxonomy General Name', 'text_domain' ),
		'singular_name'              => _x( $dbstax->post_title, 'Taxonomy Singular Name', 'text_domain' ),
		'menu_name'                  => __( $dbstax->post_title, 'text_domain' ),
		'all_items'                  => __( 'All Items', 'text_domain' ),
		'parent_item'                => __( 'Parent Item', 'text_domain' ),
		'parent_item_colon'          => __( 'Parent Item:', 'text_domain' ),
		'new_item_name'              => __( 'New Item Name', 'text_domain' ),
		'add_new_item'               => __( 'Add New Item', 'text_domain' ),
		'edit_item'                  => __( 'Edit Item', 'text_domain' ),
		'update_item'                => __( 'Update Item', 'text_domain' ),
		'separate_items_with_commas' => __( 'Separate items with commas', 'text_domain' ),
		'search_items'               => __( 'Search Items', 'text_domain' ),
		'add_or_remove_items'        => __( 'Add or remove items', 'text_domain' ),
		'choose_from_most_used'      => __( 'Choose from the most used items', 'text_domain' ),
		'not_found'                  => __( 'Not Found', 'text_domain' ),
	);
	$args = array(
		'labels'                     => $labels,
		'hierarchical'               => true,
		'public'                     => true,
		'show_ui'                    => true,
		'show_admin_column'          => true,
		'show_in_nav_menus'          => true,
		'show_tagcloud'              => true,
	);
	register_taxonomy( $dbstax->post_name,'post', $args );
endforeach; 
wp_reset_postdata();



}



add_action( 'init', 'fw_matrix_cpt', 0 );


add_action('save_post', 'add_post_as_term');



function add_post_as_term( $postid ) {
  if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) return;
  $post = get_post($postid);
  if ( $post->post_type == 'post' AND has_term( 'wer', 'data')) { // change 'post' to any cpt you want to target
    $term = get_term_by('slug', $post->post_name, 'wer');
    if ( empty($term) ) {
      $add = wp_insert_term( $post->post_title, 'wer', array('slug'=> $post->post_name) );
      if ( is_array($add) && isset($add['term_id']) ) {
        wp_set_object_terms($postid, $add['term_id'], 'wer', true );
      }
    }
  }
	 if ( $post->post_type == 'post' AND has_term( 'was', 'data')) { // change 'post' to any cpt you want to target
    $term = get_term_by('slug', $post->post_name, 'was');
    if ( empty($term) ) {
      $add = wp_insert_term( $post->post_title, 'was', array('slug'=> $post->post_name) );
      if ( is_array($add) && isset($add['term_id']) ) {
        wp_set_object_terms($postid, $add['term_id'], 'was', true );
      }
    }
  }


}

//custom meta boxes
$prefix = 'matrix';

$matrix_meta_box = array(
    'id' => 'MatrixMetaBox',
    'title' => 'Matrix',
    'context' => 'normal',
    'priority' => 'high',
    'fields' => array(
    	array(
        	'name' => __('Belegdatum'),
        	'id' => $prefix . 'belegdatum',
        	'type' => 'date',
        	'desc' => __('Belegdatum'),
        	'std' => ''
     	),
     	
  
  array(
        	'name' => __('Eingang'),
        	'id' => $prefix . 'eingang',
        	'type' => 'text',
        	'desc' => __('Geld kommt in die Kassa'),
        	'std' => ''
     	),
    	array(        	'name' => __('Ausgang'),
        	'id' => $prefix . 'ausgang',
        	'type' => 'text',
        	'desc' => __('Geld geht aus der Kassa'),
        	'std' => ''
     	),
     	array(
        	'name' => __('Offen'),
        	'id' => $prefix . 'offen',
        	'type' => 'text',
        	'desc' => __('Gruppe'),
        	'std' => ''
     	),
     	array(
        	'name' => __('Name'),
        	'id' => $prefix . 'name',
        	'type' => 'text',
        	'desc' => __('Name des Belegempfänger, Belegsenders'),
        	'std' => ''
     	),
     		array(
        	'name' => __('Anmerkung'),
        	'id' => $prefix . 'anmerkung',
        	'type' => 'text',
        	'desc' => __(''),
        	'std' => ''
     	),
  
     	
     	

         )
);


function MatrixAddMetaBoxes() {
    global $matrix_meta_box, $posted;
    	
	$post_types = get_post_types(array('public' => true, 'show_ui' => true), 'objects');
	//foreach ($post_types as $page)     
	add_meta_box($matrix_meta_box['id'], $matrix_meta_box['title'], 'MatrixMetaBox', 'matrix', $matrix_meta_box['context'], $matrix_meta_box['priority']);
	
	
     
}
add_action('admin_menu', 'MatrixAddMetaBoxes');

function MatrixMetaBox()
{
	global $matrix_meta_box, $post;
  
	echo "TERMS";
	$args = array( 'hide_empty=0' );
 
$terms = get_terms( 'category', $args );
if ( ! empty( $terms ) && ! is_wp_error( $terms ) ) {
    $count = count( $terms );
    $i = 0;
    $term_list = '<p class="my_term-archive">';
    foreach ( $terms as $term ) {
        $i++;
        $term_list .= '<a href="' . esc_url( get_term_link( $term ) ) . '" alt="' . esc_attr( sprintf( __( 'View all post filed under %s', 'my_localization_domain' ), $term->name ) ) . '">' . $term->name . '</a>';
        if ( $count != $i ) {
            $term_list .= ' &middot; ';
        }
        else {
            $term_list .= '</p>';
        }
    }
    echo $term_list;
}

	echo "TERM LIST POST<br/>";
	echo get_the_term_list($post->ID, "category",$bvor , " ", $after );
	
 echo "<br/>TAXONOMIES<br/>"; 
$args = array(
  'public'   => true,
  
  
); 
$output = 'names'; // or objects
$operator = 'and'; // 'and' or 'or'
$taxonomies = get_taxonomies( $args, $output, $operator ); 
if ( $taxonomies ) {
  foreach ( $taxonomies  as $taxonomy ) {
    echo '<p>' . $taxonomy . '</p>';
  }
}
  echo "POST TYPES<BR/>";
  
  
$args = array(
   'public'   => true,
);

  
$output = 'names'; // names or objects, note names is the default
$operator = 'and'; // 'and' or 'or'

$post_types = get_post_types( $args, $output, $operator ); 

foreach ( $post_types  as $post_type ) {

   echo '<p>' . $post_type . '</p>';
}
echo "<table>";
 foreach ($matrix_meta_box['fields'] as $field) {
        // get current post meta data
        echo "<tr>";
        $meta = get_post_meta($post->ID, $field['id'], true);
        
        switch ($field['type']) {
        	case 'text':
        		echo '<td>'.$field['name'].':</td><td> <input type="text" name="', $field['id'], '" id="', $field['id'], '" value="'.$meta.'" />'.$field['desc'].'</td>';
        		break;
	case 'editor':
	//	the_editor($post->post_content);
        		
        		break;
        			case 'date':
        				if ($meta!='')
        				{$tidate = new DateTime($meta);
$dmeta= $tidate->format('d.m.Y');
}


echo '<td>'.$field['name'].':</td><td> <input class="calendarpicker hasDatepicker" type="text" name="', $field['id'], '" id="', $field['id'], '" value="'.$dmeta.'" />'.$field['desc'].'</td>';
echo '<script type="text/javascript">jQuery(document).ready(function() {    jQuery(\'#termindatum\').calendarpicker({        dateFormat : \'dd.mm.yy\'/   });});</script>';

break;
            case 'date2':
            $metas = get_post_meta($post->ID, $field['id'], false);
            
            
        				if ($meta!='')
        				{$tidate = new DateTime($meta);
$dmeta= $tidate->format('d.m.Y');
}
foreach ($metas as $d2meta) {
echo '<td>'.$field['name'].':</td><td> <input type="text" name="', $field['id'], '" id="', $field['id'], '" value="'.$d2meta.'" />'.$field['desc'].'</td>';
}
            echo '<td>'.$field['name'].':</td><td> <input class="calendarpicker" type="text" name="', $field['id'], '" id="', $field['id'], '" value="" />'.$field['desc'].'</td>';
//echo '<script type="text/javascript"> jQuery(document).ready(function() {    jQuery(\'#testdatum\').datepicker({        dateFormat : \'dd.mm.yy\'    });});</script>';

break;
	case 'editor':
	//	the_editor($post->post_content);
        		
        		break;
        		            case 'select':
            	echo "selected Box";
                break;
            case 'checkbox':
                echo '<input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' />';
                break;
        }
        echo "</tr>";

}
echo '</table>';	
}


add_action('save_post', 'add_title_as_category');



function add_title_as_category( $postid ) {
  if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) return;
$post = get_post($postid);
  if ( $post->post_type == 'post' ) { // change 'post' to any cpt you want to target
	 // $term = get_term_by('slug', $post->post_name, 'node');
//    if ( empty($term) ) {
//      $add = wp_insert_term( $post->post_title, 'node', array('slug'=> $post->post_name) );
 $thecontent= get_the_content();
     if (empty_content($post->post_content)){
		wp_remove_object_terms($postid, 'content-oin', 'status');
	 }
	  else
	  {
		wp_set_object_terms($postid, 'content-oin', 'status', true ); 
	 
		  }
		 if (get_post_meta( $postid, 'oin-Homepage', true )) {
		wp_set_object_terms($postid, 'homepage', 'status', true ); 
	  }
	  else
	  {
		wp_remove_object_terms($postid, 'homepage', 'status');
	 
		  }
	   if (get_post_meta( $postid, 'oin-kontaktemail', true )) {
		wp_set_object_terms($postid, 'email', 'status', true ); 
	  }
	  else
	  {
		wp_remove_object_terms($postid, 'email', 'status');
	 
		  }
        wp_set_object_terms($postid, 'erfasst', 'status', true );
	
      }
	
}
function empty_content($str) {
    return trim(str_replace('&nbsp;','',strip_tags($str))) == '';
}
function Matrix_Post_Metabox( $meta_boxes ) {
	$prefix = 'oin-';

	$meta_boxes[] = array(
		'id' => 'Box',
		'title' => esc_html__( 'Box', 'metabox-online-generator' ),
		'post_types' => array( 'post' ),
		'context' => 'advanced',
		'priority' => 'high',
		'autosave' => true,
		'fields' => array(
			array(
				'id' => $prefix . 'Homepage',
				'type' => 'url',
				'name' => esc_html__( 'Homepage', 'metabox-online-generator' ),
				'desc' => esc_html__( 'Homepage', 'metabox-online-generator' ),
				'placeholder' => esc_html__( 'http://', 'metabox-online-generator' ),
			),
			
			array(
				'id' => $prefix . 'user',
				'type' => 'user',
				'name' => esc_html__( 'User', 'metabox-online-generator' ),
				'field_type' => 'select',
			),
			array(
				'id' => $prefix . 'kontaktperson',
				'type' => 'text',
				'name' => esc_html__( 'Kontaktperson', 'metabox-online-generator' ),
			),
			array(
				'id' => $prefix . 'kontaktemail',
				'name' => esc_html__( 'KontaktEmail', 'metabox-online-generator' ),
				'type' => 'email',
			),
			array(
				'id' => $prefix . 'anmerkungen',
				'type' => 'textarea',
				'name' => esc_html__( 'Anmerkungen', 'metabox-online-generator' ),
			),
						array(
				'id' => $prefix . 'kriterien',
				'name' => esc_html__( 'Kriterien', 'metabox-online-generator' ),
				'type' => 'checkbox_list',
				'options' => array(
					'Offen' => 'Offen',
					'Frei' => 'Frei',
					'Regional' => 'Regional',
					'Nachhaltig' => 'Nachhaltig',
					'Zivilgesellschaft' => 'Zivilgesellschaft',
					'Gemeinwohl' => 'Gemeinwohl',
					'Vernetzung' => 'Vernetzung',
					'Gewerbe' => 'Gewerbe',
					'unbekannt' => 'unbekannt',
				),
				'std' => array( 'Offen' ),
			),
			array(
				'id' => $prefix . 'bundesland',
				'name' => esc_html__( 'Bundesland', 'metabox-online-generator' ),
				'type' => 'select',
				'desc' => esc_html__( 'Bundesland', 'metabox-online-generator' ),
				'placeholder' => esc_html__( 'Wähle aus (mehrfach möglichI)', 'metabox-online-generator' ),
				'options' => array(
					'Wien' => 'Wien',
					'Niederösterreich' => 'Niederösterreich',
					'Oberösterreich' => 'Oberösterreich',
					'Salzburg' => 'Salzburg',
					'Tirol' => 'Tirol',
					'Vorarlberg' => 'Vorarlberg',
					'Kärnten' => 'Kärnten',
					'Steiermark' => 'Steiermark',
					'Burgenland' => 'Burgenland',
					'Österreich' => 'Österreich',
					'Deutschland' => 'Deutschland',
					'International' => 'International',
				),
				'multiple' => true,
			),
			array(
				'id' => $prefix . 'adresse',
				'type' => 'text',
				'name' => esc_html__( 'Adresse', 'metabox-online-generator' ),
			),
			array(
				'id' => $prefix . 'ort',
				'type' => 'text',
				'name' => esc_html__( 'ort', 'metabox-online-generator' ),
			),            
			array(
				'id' => $prefix . 'plz',
				'type' => 'text',
				'name' => esc_html__( 'plz', 'metabox-online-generator' ),
			),
			
			array(
				'id' => $prefix . 'status',
				'name' => esc_html__( 'Status', 'metabox-online-generator' ),
				'type' => 'checkbox_list',
				'options' => array(
					'Eintrag' => 'Eintrag',
					'nachbearbeitet' => 'nachbearbeitet',
					'Check' => 'Check',
					'Kontakt' => 'Kontakt',
					'gesperrt' => 'gesperrt',
					'nichtaktiv' => 'nichtaktiv',
					),
				'std' => array( 'Eintrag' ),			
		), 
			array(
				'id' => $prefix . 'taxonomy_advanced_5',
				'type' => 'taxonomy_advanced',
				'name' => esc_html__( 'Taxonomy Advanced', 'metabox-online-generator' ),
				'taxonomy' => 'category',
				'field_type' => 'checkbox_tree',
			),
			array(
				'id' => $prefix . 'user_6',
				'type' => 'user',
				'name' => esc_html__( 'User', 'metabox-online-generator' ),
				'field_type' => 'checkbox_list',
			),	
			
		), // fields array

		); //meta_boxes Array

	return $meta_boxes;
}
// https://metabox.io/online-generator/

add_filter( 'rwmb_meta_boxes', 'Matrix_Post_Metabox' );

    // define the the_author callback 
    function filter_the_author( $author_display_name ) { 
       // $author_display_name='nur so test'; // make filter magic happen here... 
		//$author_display_name.=coauthors_posts_links();
        return $author_display_name; 
    }; 
             
    // add the filter 
    add_filter( 'the_author', 'filter_the_author', 10, 1 ); 

// Add a shortcode that executes our function
add_shortcode( 'matrixlinks', 'matrix_links' );

function matrix_links( $atts ) {
 
  $output="";
  $terms= get_terms( array( 
    'taxonomy' => 'was'
) );
  if ( ! empty( $terms ) && ! is_wp_error( $terms ) ){
	 $output.='<ul>';
    foreach ( $terms as $term ) {
	//    $output.='<li>' . $term->name . '</li>';
    }
	$output.= '</ul>';
}
// Inside the function we extract custom taxonomy parameter of our shortcode
 
    extract( shortcode_atts( array(
      'titel' => 'Was - Projekte', 
	  'data' => 'was',
	  'tax' => 'wer',
	  'terms' => '',
	  'posttype' => 'post',
    ), $atts ) );

  if ($data!="")
  {$argsdata = array(
	'relation' => 'AND',
		array(
			'taxonomy' => 'data',
			'field'    => 'slug',
			'terms'    => $data,
		),
	);
  }
  $terma = get_the_terms( get_the_ID(), $tax );

if ($terma!="")
{
	//$output.="terms";
foreach ( $terma as $termi ){
		  
  $termsa=  $termi->name.' ';
$termslug=$termi->slug.',';
	//$output.=$termsa; 
}
}  
  	
  $args = array(
	'post_type' => $posttype,
     'posts_per_page'=>-1,
	  'tax_query' => array(
	  // 'was',
		  $argsdata, 
	  
		array(
			'taxonomy' => $tax,
			'field'    => 'slug',
			'terms'    => array($termslug),
		
		),
	  
	), 
	
	);
 $output.=$titel;
	//.' '.$terms;  
// The Query
$the_query = new WP_Query( $args );

// The Loop
if ( $the_query->have_posts() ) {
	$output.= '<ul>';
	while ( $the_query->have_posts() ) {
		$the_query->the_post();
	  $output.= '<li><a href="'.get_permalink().'">' . get_the_title() . '</a></li>'.get_post_meta( get_the_ID(), '_event_start_date', true ).' '.get_post_meta( get_the_ID(), '_event_start_time', true );
;
	}
	$output.= '</ul>';
	/* Restore original Post Data */
	wp_reset_postdata();
} else {
	// no posts found
  $output.="</br>keine weiteren Informationen vorhanden";
}
  return $output;
}
 



?>